AddCSLuaFile("shared.lua");
include('shared.lua');

function ENT:OnTakeDamage(damageInfo)
end

function ENT:Initialize(thisClass)
	--print("init name: "..self.PrintName);
	--print("base_cp_control_point:Initialize()");
	--print("thisClass: ", thisClass.PrintName);

	self:BaseClassInitialize(thisClass);

	self:ProcessBaseCPControlPointKeyValues();
end

function ENT:AcceptInput(name, activator, caller, params)
	if(name == "SetOwner") then
		self:SetOwningTeam(params);
	end
end

--processes the control point's key values
--TODO: error checking
function ENT:ProcessBaseCPControlPointKeyValues()
	--set up sounds
	--self:CacheCPSound("team_capsound_0", self:GetCPKeyValues()["team_capsound_0"]);
	--self:CacheCPSound("team_capsound_2", self:GetCPKeyValues()["team_capsound_2"]);
	--self:CacheCPSound("team_capsound_3", self:GetCPKeyValues()["team_capsound_3"]);

	self:SetOwningTeam(self:GetCPKeyValues()["point_default_owner"]);
end

function ENT:CacheCPSound(soundTag, soundPath)
	if(self.CPSounds == nil) then
		self.CPSounds = {};
	end

	print("SoundPath: ", soundPath);

	self.CPSounds[soundTag] = CreateSound(self, soundPath);
end

function ENT:Think()
	--need to set next think so the animations run smoothly
	self:NextThink(CurTime());
	return true;
end

function ENT:SetOwningTeam(teamId)
	--TODO: error checking
	if(!teamId or !tonumber(teamId)) then return end

	self.OwningTeamId = tonumber(teamId);

	--TODO: should also check don't show model spawn flag here
	if(self:GetCPKeyValues()["team_model_"..self.OwningTeamId]) then
		self.Entity:SetModel(self:GetCPKeyValues()["team_model_"..self.OwningTeamId]);
		self.Entity:ResetSequence(self.Entity:LookupSequence("idle"));
		
	--TODO: why are the bodygroup numbers all wonky? They are the opposite of the index the modelviewer says they are
	--TODO: bodygroup mapping function
	self.Entity:Input("setbodygroup", nil, self.Entity, 3 - tonumber(self:GetCPKeyValues()["team_bodygroup_"..self.OwningTeamId]));
	else
		--don't draw the entity if the model is nil
		self.Entity:SetNoDraw(true);
	end

	--self.CPSounds["team_capsound_"..tostring(teamId)]:Play();
end

function ENT:GetOwningTeamId()
	return tonumber(self.OwningTeamId);
end

function ENT:CP_OnStartCap(triggerArea)
	if(self.StartCapSound) then
		self.Entity:EmitSound(self.StartCapSound);
	end
	--self.CappingSound:PlayEx(1, 100);
end

function ENT:CP_OnEndCap(triggerArea)
	--self.CappingSound:Stop();
	if(self.EndCapSound) then
		self.Entity:EmitSound(self.EndCapSound);
	end
	self:SetOwningTeam(triggerArea:GetCapturingTeamId());
end

function ENT:CP_OnExpireCap()
	--self.CappingSound:Stop();
	if(self.ExpireCapSound) then
		self.Entity:EmitSound(self.ExpireCapSound);
	end
end
