AddCSLuaFile("shared.lua");
include("shared.lua");

--utility accessor func
--creates accessor functions
--also initializes the variable due to variable inheritance issues
function InitAccessorFunc(t, varName, initialValue)
	t["Get"..varName] = function(self)
		if(self[varName] == nil) then
			--tables need to be a copy or else all instances of the entity will
			--share the same initial value
			if(type(initialValue) == "table") then
				self[varName] = table.Copy(initialValue);
			else
				self[varName] = initialValue
			end
		end
		return self[varName];
	end

	t["Set"..varName] = function(self, v)
		self[varName] = v;
	end
end



function ENT:Initialize(thisClass)
	--this initialization passes the final class as self to all init functions
	--if(thisClass) then
	--	thisClass.BaseClass.Initialize(self, thisClass.BaseClass);
	--else
	--	self.BaseClass.Initialize(self, self.BaseClass);
	--end
end

--this initialization passes the final class as self to all init functions
function ENT:BaseClassInitialize(thisClass)
	if(thisClass and thisClass.BaseClass) then
		thisClass.BaseClass.Initialize(self, thisClass.BaseClass);
	elseif(self.BaseClass and self.BaseClass.Initialize) then
		self.BaseClass.Initialize(self, self.BaseClass);
	end
end

--redefine GetKeyValues
--local meta = FindMetaTable("Entity");
--meta.OriginalGetKeyValues = meta.GetKeyValues;

--function meta:GetKeyValues()
function ENT:GetCPKeyValues()
	--local originalKeyValues = self:OriginalGetKeyValues();
	--local originalKeyValues = self:GetKeyValues();

	local keyValueCopy = {};
	--table.Merge(keyValueCopy, originalKeyValues);

	if(self.CPKeyValues) then
		table.Merge(keyValueCopy, self.CPKeyValues);
	end

	return keyValueCopy;
end

--Handle key values and outputs
--TODO: Implement callbacks for handling specific key/values?
function ENT:KeyValue(key, value)
	--handle outputs that start with "On"
	if(string.sub(key, 1, 2) == "On") then
		self:StoreOutput(key, value);
	else
		if(!self.CPKeyValues) then
			self.CPKeyValues = {};
		end

		--otherwise, assume it's a standard key/value pair
		self.CPKeyValues[key] = value;
	end
end
