
GM.Name 	= "Control Points"
GM.Author 	= "mrflippy"
GM.Email 	= ""
GM.Website 	= ""

DeriveGamemode( "fretta" )
IncludePlayerClasses()	

GM.Help		= "Stand on the control points to capture them."
GM.TeamBased = true
GM.AllowAutoTeam = true
GM.AllowSpectating = true
GM.SelectClass = false
GM.SecondsBetweenTeamSwitches = 10
GM.GameLength = 10
GM.NoPlayerDamage = false
GM.NoPlayerSelfDamage = false
GM.NoPlayerTeamDamage = true
GM.NoPlayerPlayerDamage = false
GM.NoNonPlayerPlayerDamage = false
GM.TakeFragOnSuicide = false
GM.AddFragsToTeamScore = false

GM.RoundBased = true;
GM.RoundLength = 300;
GM.RoundEndsWhenOneTeamAlive = false;

TEAM_RED = 1 
TEAM_BLUE = 2


function GM:CreateTeams()

	if ( !GAMEMODE.TeamBased ) then return end
	
	team.SetUp( TEAM_RED, "Team Red", Color( 255, 80, 80 ) )
	team.SetSpawnPoint( TEAM_RED, {"info_player_terrorist", "info_player_combine" }, true )
	
	team.SetUp( TEAM_BLUE, "Team Blue", Color( 80, 150, 255 ) )
	team.SetSpawnPoint( TEAM_BLUE, {"info_player_counterterrorist", "info_player_rebel" }, true )
	
	team.SetUp( TEAM_SPECTATOR, "Spectators", Color( 200, 200, 200 ), true )
	team.SetSpawnPoint( TEAM_SPECTATOR, { "info_player_start", "info_player_terrorist", "info_player_counterterrorist", "info_player_combine", "info_player_rebel" } ) 

end
